package nl.amis.view;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import java.util.Set;

import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.el.ELContext;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import javax.faces.event.ValueChangeEvent;

import oracle.adf.view.rich.component.rich.data.RichTable;

import org.apache.myfaces.trinidad.change.AttributeComponentChange;
import org.apache.myfaces.trinidad.change.ComponentChange;
import org.apache.myfaces.trinidad.change.SessionChangeManager;
import org.apache.myfaces.trinidad.event.AttributeChangeEvent;

public class TableListener {

    private RichTable empTable;

    public void attributeChangeListener(AttributeChangeEvent attributeChangeEvent) {
        // Add event code here...
        System.out.println(attributeChangeEvent.getAttribute());
        System.out.println(attributeChangeEvent.getComponent().getId());
        System.out.println(attributeChangeEvent.getNewValue() + " old value " +
                           attributeChangeEvent.getOldValue());

        reportAllChangesCurrentPagePersistentChangeManager();

    }
    public void colattributeChangeListener(AttributeChangeEvent attributeChangeEvent) {
        // Add event code here...
        System.out.println(attributeChangeEvent.getAttribute());
        System.out.println(attributeChangeEvent.getComponent().getId());
        System.out.println(attributeChangeEvent.getNewValue() + " old value " +
                           attributeChangeEvent.getOldValue());

        reportAllChangesCurrentPagePersistentChangeManager();

    }
    private void reportAllChangesCurrentPagePersistentChangeManager() {
        // get hold of #{SessionWideChangePersistenceManager} and invoke applyPersistentChanges()
        FacesContext ctx = FacesContext.getCurrentInstance();
        ELContext elCtx = ctx.getELContext();
        Application app = ctx.getApplication();

        SessionWideChangePersistenceManager mgr =
            (SessionWideChangePersistenceManager)app.evaluateExpressionGet(ctx,
                                                                           "#{SessionWideChangePersistenceManager}",
                                                                           SessionWideChangePersistenceManager.class);
        mgr.reportAllComponentChanges();

    }


    public void setEmpTable(RichTable empTable) {
        this.empTable = empTable;


        // now apply some attribute component changes
        UIComponent col = empTable.findComponent("colJob");
        if (col != null) {
            SessionChangeManager cm = new SessionChangeManager();
            AttributeComponentChange acc =
                new AttributeComponentChange("visible", false);
            //cm.addComponentChange(FacesContext.getCurrentInstance(), col, acc);

            //acc.changeComponent(col);
        }
    }

    public RichTable getEmpTable() {
        return empTable;
    }

    public void ThemeChangeListener(ValueChangeEvent valueChangeEvent) {
        applyThemeChanges((String)valueChangeEvent.getNewValue());
    }

    private void applyThemeChanges(String theme) {

        Map viewMap =
            SessionWideChangePersistenceManager.getComponentToChangesMapForView(FacesContext.getCurrentInstance(),
                                                                                FacesContext.getCurrentInstance().getViewRoot().getViewId(),
                                                                                true);

        String uid = "empTablePanelCollection:empTable:colmgr";

        AttributeComponentChange accWidth =

            new AttributeComponentChange("width",
                                         ("small".equalsIgnoreCase(theme) ?
                                          50 :
                                          ("normal".equalsIgnoreCase(theme) ?
                                           130 : 400)));
        AttributeComponentChange accStyle =

            new AttributeComponentChange("inlineStyle",
                                         ("small".equalsIgnoreCase(theme) ?
                                          "background-color:yellow" :
                                          ("normal".equalsIgnoreCase(theme) ?
                                           "background-color:gray" :
                                           "background-color:blue")));

        SessionWideChangePersistenceManager.addChangesToComponent(uid, viewMap,
                                      new ComponentChange[] { accWidth, accStyle});

        UIComponent col = FacesContext.getCurrentInstance().getViewRoot().findComponent(uid);
        if (col != null) {
            accWidth.changeComponent(col); 
            accStyle.changeComponent(col); 
        }

    }




}
